Mocking
=======

[![Stable Documentation](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliatesting.github.io/Mocking.jl/stable)
[![Dev Documentation](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliatesting.github.io/Mocking.jl/dev)
[![CI](https://github.com/JuliaTesting/Mocking.jl/workflows/CI/badge.svg)](https://github.com/JuliaTesting/Mocking.jl/actions?query=workflow%3ACI+branch%3Amain)
[![codecov](https://codecov.io/gh/JuliaTesting/Mocking.jl/graph/badge.svg?token=BkilUame8F)](https://codecov.io/gh/JuliaTesting/Mocking.jl)
[![Code Style: Blue](https://img.shields.io/badge/code%20style-blue-4495d1.svg)](https://github.com/invenia/BlueStyle)
[![ColPrac: Contributor Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac)

Allows Julia function calls to be temporarily overloaded for the purpose of testing.

# Use Julia's `jl_type_morespecific` function to emulate Julia's multiple dispatch across
# generic functions.
#
# Origin:
# https://github.com/JuliaLang/julia/blob/master/doc/src/devdocs/types.md#subtyping-and-method-sorting
type_morespecific(a, b) = ccall(:jl_type_morespecific, Bool, (Any, Any), a, b)

"""
    anonymous_signature(m::Method) -> Type{<:Tuple}

Construct a Tuple of the methods signature with the function type removed

# Example
```@meta
DocTestSetup = quote
    using Mocking: anonymous_signature
end
```

```jldoctest
julia> m = first(methods(first, (String,)));

julia> m.sig
Tuple{typeof(first), Any}

julia> anonymous_signature(m)
Tuple{Any}
```

```@meta
DocTestSetup = nothing
```
"""
anonymous_signature(m::Method) = anonymous_signature(m.sig)
anonymous_signature(sig::DataType) = Tuple{sig.parameters[2:end]...}
anonymous_signature(sig::UnionAll) = UnionAll(sig.var, anonymous_signature(sig.body))

"""
    anon_morespecific(a::Method, b::Method) -> Bool

Determine which method is more specific for multiple dispatch without considering the
function type. By not considering the function type we can determine which method is more
specific as if they are a part of the same generic function.
"""
function anon_morespecific(a::Method, b::Method)
    # Drop the function type from the parameter
    a_sig = anonymous_signature(a)
    b_sig = anonymous_signature(b)

    return type_morespecific(a_sig, b_sig)
end

"""
    dispatch(funcs::AbstractVector, args...) -> Tuple{Method, Any}

Choose which method to execute based upon the provided arguments (values not types).
Emulates Julia's multiple dispatch system but allows for dispatching between methods of
multiple generic functions instead of just methods of a single generic function. Returns a
tuple of the selected method and the generic function of the method.

When the function to dispatch to is ambiguous last ambiguous function in the vector is used.
"""
function dispatch(funcs::AbstractVector, args...)
    arg_types = map(Core.Typeof, args)

    best_method = nothing
    best_function = nothing
    for f in reverse(funcs)
        # Since arguments will be using concrete types `methods` should only return up to
        # one method.
        for m in methods(f, arg_types)
            if best_method === nothing || anon_morespecific(m, best_method)
                best_method = m
                best_function = f
            end
        end
    end

    return best_method, best_function
end

# Patches should allow using imported bindings in the body of the patch
@testset "imported binding in body" begin
    @test_throws UndefVarError Minute
    @test isdefined(Dates, :Minute)
    using Dates: Minute, Hour

    myminute(x::Integer) = Minute(x)

    # Patches should work when referencing bindings imported in the file where the patch
    # is created.
    patch = @patch myminute(x::Integer) = Minute(Hour(x))
    apply(patch) do
        @test (@mock myminute(5)) == Minute(300)
    end
end

# Patches should allow using <module>.<binding> syntax in the signature
@testset "qualified binding in signature" begin
    @test_throws UndefVarError AbstractCmd
    @test isdefined(Base, :AbstractCmd)

    patch = @patch read(cmd::Base.AbstractCmd, ::Type{String}) = "bar"
    apply(patch) do
        @test (@mock read(`foo`, String)) == "bar"
    end
end

# Patches should allow using imported bindings syntax in the signature
@testset "imported binding in signature" begin
    using Base: AbstractCmd

    patch = @patch read(cmd::AbstractCmd, ::Type{String}) = "bar"
    apply(patch) do
        @test (@mock read(`foo`, String)) == "bar"
    end
end

using Test
using Mocking

# Issue #108
@testset "patching an async task from an earlier world age" begin
    function foo(x)
        @mock bar(x)
    end

    bar(x) = x

    # Before the patch
    @test bar(2) == 2

    # NOTE: Every top-level statement in a testset is run in a new world age.
    if VERSION >= v"1.5"
        intial_world_age = Base.get_world_counter()
    end

    # Start a background, async task which blocks until bar() is patched, so that we
    # can test that patches to functions defined in later world ages can be called
    # from mocks in a Task running in an earlier world age.
    ch = Channel() do ch
        # Wait until there is data in the channel
        v1 = take!(ch)
        # Call the (patched) `foo`
        v2 = foo(v1)
        # Return the value into the channel
        put!(ch, v2)
    end

    # Make sure we're actually testing what we think we are.
    if VERSION >= v"1.5"
        @assert Base.get_world_counter() > intial_world_age
    end

    p = @patch bar(x) = 10 * x

    apply(p) do
        # Release the background task
        put!(ch, 2)
        # Fetch the task's result
        @test take!(ch) == 20
    end
end

using Documenter
using Mocking: Mocking

setup = quote
    using Mocking: @mock, @patch, activate, apply
    activate()
end

DocMeta.setdocmeta!(Mocking, :DocTestSetup, setup; recursive=true)

makedocs(;
    modules=[Mocking],
    authors="Curtis Vogt and contributors",
    sitename="Mocking.jl",
    format=Documenter.HTML(;
        canonical="https://juliatesting.github.io/Mocking.jl",
        edit_link="main",
        assets=String[],
        prettyurls=get(ENV, "CI", nothing) == "true",  # Fix links in local builds
    ),
    pages=[
        "Home" => "index.md",
        "FAQ" => "faq.md",
        "API" => "api.md",
        # format trick: using this comment to force use of multiple lines
    ],
    warnonly=[:missing_docs],
)

deploydocs(; repo="github.com/JuliaTesting/Mocking.jl", devbranch="main")

# Test that Mocking can interact with functions defined at different scopes or externally

# Global scope
global_scope() = "org"

# The @mock macro is essentially a no-op
@test (@mock global_scope()) == global_scope()

# Create a patched version of function
global_patch = (@patch global_scope() = "alt")
apply(global_patch) do
    @test (@mock global_scope()) != global_scope()
end

# The @mock macro should return to the original behaviour
@test (@mock global_scope()) == global_scope()

# Local scope within a function
function test_function_scope()
    function_scope() = "org"
    @test (@mock function_scope()) == function_scope()

    patch = @patch function_scope() = "alt"
    apply(patch) do
        @test (@mock function_scope()) != function_scope()
    end

    @test (@mock function_scope()) == function_scope()
end

test_function_scope()

# Local scope within a let-block
let let_scope
    let_scope() = "org"
    @test (@mock let_scope()) == let_scope()

    patch = @patch let_scope() = "alt"
    apply(patch) do
        @test (@mock let_scope()) != let_scope()
    end

    @test (@mock let_scope()) == let_scope()
end

@testset "qualified function" begin
    # Define a new generic function named zero
    zero() = 0

    patch = @patch Base.zero(T::Type{<:Integer}) = one(T)
    apply(patch) do
        # Call alternative
        @test (@mock Base.zero(Int)) == 1

        # Call original function
        @test (@mock Base.zero(1)) == 0

        # Call new function named zero
        @test (@mock zero()) == 0
        @test_throws MethodError (@mock zero(1))
    end
end

@testset "constructor function" begin
    @test Vector() == []

    p = @patch Vector() = [1, 2, 3]
    apply(p) do
        # Call alternative
        @test (@mock Vector()) == [1, 2, 3]
        @test (@mock Base.Vector()) == [1, 2, 3]

        # Call original function
        @test (@mock Base.Vector{Any}()) == Any[]
    end
end

struct Coefficient
    x
end

(c::Coefficient)(y) = c.x * y

# https://docs.julialang.org/en/v1/manual/methods/#Function-like-objects-1
@testset "function-like objects" begin
    c = Coefficient(2)

    p = @patch (c::Coefficient)(y::Integer) = c.x + y
    apply(p) do
        # Call alternative
        @test (@mock c(3)) == 5

        # Call original function
        @test (@mock c(3.0)) == 6.0
    end
end

@testset "missing target" begin
    # The function `f` is not defined so we cannot target it.
    @test !isdefined(@__MODULE__, :f)
    @test_throws UndefVarError (@patch f() = 1)
end

# Test that @mock works within the context of a patch.
#
# WARNING: Do not use the following code as a template as this test is for illustration
# purposes only. Typically the way this problem is handled is by using `@mock foo(...)`
# within the original function declaration of `foo(::AbstractArray)`.
@testset "mock in patch" begin
    foo(arr::AbstractArray{Float64}) = map(foo, arr)  # Typically foo should use @mock here
    foo(x::Float64) = floor(x)

    # Patching only the function that takes a scalar
    #! format: off
    patches = Patch[
        @patch foo(x::Float64) = ceil(x)
    ]
    #! format: on

    @test (@mock foo(1.6)) == 1.0

    apply(patches) do
        @test (@mock foo(1.6)) == 2.0
        @test (@mock foo([1.6])) == [1.0]  # Ends up calling original function
    end

    # Create a set of patches where @mock is used within a @patch
    patches = Patch[
        @patch foo(arr::AbstractArray{Float64}) = map(x -> (@mock foo(x)), arr)
        @patch foo(x::Float64) = ceil(x)
    ]

    apply(patches) do
        @test (@mock foo(1.6)) == 2.0
        @test (@mock foo([1.6])) == [2.0]
    end
end

# https://github.com/JuliaTesting/Mocking.jl/issues/59
@testset "patch calls patch" begin
    f(args...) = 0

    patches = [
        @patch f(a::Function, b) = b
        @patch f(b) = @mock f(() -> nothing, b)
    ]

    apply(patches) do
        @test (@mock f(identity, 1)) == 1
        @test (@mock f(1)) == 1
    end
end

@testset "closure" begin
    magic(x) = false
    sentinel = gensym("sentinel")
    @test magic(sentinel) == false

    # Getting closers to work means having a function created in the current scope
    patch = @patch magic(x) = x == sentinel
    apply(patch) do
        @test (@mock magic(sentinel)) == true
    end
end

# https://github.com/JuliaTesting/Mocking.jl/issues/56
@testset "kwarg default uses arg" begin
    function f end

    p = @patch function f(x; y=x)
        return (x, x, y, y)
    end

    apply(p) do
        @test (@mock f(1)) == (1, 1, 1, 1)
        @test (@mock f(1, y=2)) == (1, 1, 2, 2)
    end
end

# https://github.com/JuliaTesting/Mocking.jl/issues/57
@testset "kwarg default uses symbol" begin
    function f end

    p = @patch function f(x; y=:foo)
        return (x, x, y, y)
    end

    apply(p) do
        @test (@mock f(1)) == (1, 1, :foo, :foo)
        @test (@mock f(1, y=2)) == (1, 1, 2, 2)
    end
end

@testset "nested mock call" begin
    function readfile(filename)
        return (@mock isfile(filename)) ? read((@mock open(filename)), String) : ""
    end

    # Testing with both generic and anonymous functions
    patches = Patch[
        @patch isfile(f::AbstractString) = f == "foo"
        @patch open(f::AbstractString) = IOBuffer("bar")
    ]

    @test readfile("foo") == ""

    apply(patches) do
        @test readfile("foo") == "bar"
    end

    @test readfile("foo") == ""
end

using Mocking
using Test

using Aqua: Aqua
using Dates: Dates, Hour
using Mocking: anon_morespecific, anonymous_signature, apply, dispatch, type_morespecific

Mocking.activate()

@testset "Mocking" begin
    @testset "Code quality (Aqua.jl)" begin
        # Unable to add compat entries for stdlibs while we support Julia 1.0
        stdlibs = [:Dates, :Test]
        Aqua.test_all(Mocking; deps_compat=(; check_extras=(; ignore=stdlibs)))
    end

    include("dispatch.jl")
    include("mock.jl")
    include("patch.jl")

    include("concept.jl")
    include("targets.jl")
    include("functions.jl")
    include("import.jl")
    include("real-open.jl")
    include("real-isfile.jl")
    include("real-nested.jl")
    include("mock-in-patch.jl")
    include("randdev.jl")
    include("optional.jl")
    include("patch-gen.jl")
    include("anonymous-param.jl")
    include("reuse.jl")
    include("args.jl")
    include("merge.jl")
    include("nested_apply.jl")
    include("async.jl")
    include("issues.jl")
    include("activate.jl")
    include("async-world-ages.jl")
end

# `target` will typically a `Function` or `Type` but could also be a function-like object
struct Patch{T}
    target::T
    alternate::Function
end

"""
    @patch expr

Creates a patch from a function definition. A patch can be used with [`apply`](@ref) to
temporarily include the patch when performing multiple dispatch on `@mock`ed call sites.

See also: [`@mock`](@ref), [`apply`](@ref).
"""
macro patch(expr::Expr)
    def = splitdef(expr)

    if haskey(def, :name) && haskey(def, :body)
        target = def[:name]
    elseif !haskey(def, :name)
        throw(ArgumentError("Function definition must be a named function"))
    else
        throw(ArgumentError("Function definition must not be an empty function"))
    end

    # Include the target function name in the patch to make stack traces easier to read.
    # If the provided target uses a fully-qualified reference we'll just extract the name
    # of the function (e.g `Base.foo` -> `foo`).
    target_name = if Meta.isexpr(target, :.)
        target.args[2].value
    else
        target
    end

    def[:name] = gensym(string(target_name, "_patch"))
    alternate = combinedef(def)

    # We need to evaluate the alternate function in the context of the `@patch` macro in
    # order to support closures.
    return esc(:($Patch($target, $alternate)))
end

struct PatchEnv
    mapping::Dict{Any,Vector{Function}}
    debug::Bool
end

function PatchEnv(patches, debug::Bool=false)
    pe = PatchEnv(debug)
    apply!(pe, patches)
    return pe
end

PatchEnv(debug::Bool=false) = PatchEnv(Dict{Any,Vector{Function}}(), debug)

function Base.:(==)(pe1::PatchEnv, pe2::PatchEnv)
    return pe1.mapping == pe2.mapping && pe1.debug == pe2.debug
end

"""
    merge(pe1::PatchEnv, pe2::PatchEnv) -> PatchEnv

Merge the two `PatchEnv` instances.

This is done in such a way that the following always holds:

```
patches_1 = Patch[...]
patches_2 = Patch[...]
patches = vcat(patches_1, patches_2)

pe1 = PatchEnv(patches_1)
pe2 = PatchEnv(patches_2)
pe = PatchEnv(patches)

@assert pe == merge(pe1, pe2)
```

The `debug` flag will be set to true if either `pe1` or `pe2` have it set to true.
"""
function Base.merge(pe1::PatchEnv, pe2::PatchEnv)
    mapping = mergewith(vcat, pe1.mapping, pe2.mapping)
    return PatchEnv(mapping, pe1.debug || pe2.debug)
end

function apply!(pe::PatchEnv, p::Patch)
    alternate_funcs = get!(Vector{Function}, pe.mapping, p.target)
    # isempty(alternate_funcs) && push!(alternate_funcs, p.target)
    push!(alternate_funcs, p.alternate)
    return pe
end

function apply!(pe::PatchEnv, patches)
    for p in patches
        apply!(pe, p)
    end
    return pe
end

"""
    apply(body::Function, patches; debug::Bool=false) -> Any

Applies one or more `patches` during execution of `body`. Specifically ,any [`@mock`](@ref)
call sites encountered while running `body` will include the provided `patches` when
performing dispatch.

Multiple-dispatch is used to determine which method to call when utilizing multiple patches.
However, patch defined methods always take precedence over the original function methods.

!!! note
    Ensure you have called [`activate`](@ref) prior to calling `apply` as otherwise the
    provided patches will be ignored.

See also: [`@mock`](@ref), [`@patch`](@ref).

## Examples

Applying a patch allows the alternative patch function to be called:

```jldoctest
julia> f() = "original";

julia> p = @patch f() = "patched";

julia> apply(p) do
            @mock f()
       end
"patched"
```

Patches take precedence over the original function even when the original method is more
specific:

```jldoctest
julia> f(::Int) = "original";

julia> p = @patch f(::Any) = "patched";

julia> apply(p) do
            @mock f(1)
       end
"patched"
```

However, when the patches do not provide a valid method to call then the original function
will be used as a fallback:

```jldoctest
julia> f(::Int) = "original";

julia> p = @patch f(::Char) = "patched";

julia> apply(p) do
           @mock f(1)
       end
"original"
```

### Nesting

Nesting multiple [`apply`](@ref) calls is allowed. When multiple patches are provided for
the same method then the innermost patch takes precedence:

```jldoctest
julia> f() = "original";

julia> p1 = @patch f() = "p1";

julia> p2 = @patch f() = "p2";

julia> apply(p1) do
           apply(p2) do
               @mock f()
           end
       end
"p2"
```

When multiple patches are provided for different methods then multiple-dispatch is used to
select the most specific patch:

```jldoctest
julia> f(::Int) = "original";

julia> p1 = @patch f(::Integer) = "p1";

julia> p2 = @patch f(::Number) = "p2";

julia> apply(p1) do
           apply(p2) do
               @mock f(1)
           end
       end
"p1"
```
"""
function apply end

function apply(body::Function, pe::PatchEnv)
    prev_pe = get_active_env()
    set_active_env(merge(prev_pe, pe))
    try
        return body()
    finally
        set_active_env(prev_pe)
    end
end

function apply(body::Function, patches; debug::Bool=false)
    return apply(body, PatchEnv(patches, debug))
end

const PATCH_ENV = Ref{PatchEnv}(PatchEnv())
set_active_env(pe::PatchEnv) = (PATCH_ENV[] = pe)
get_active_env() = PATCH_ENV[]

# Nesting calls to apply should take the appropriate union of patches.
@testset "nested apply calls" begin
    multiply(x::Number) = 2x
    multiply(x::Int) = 2x - 1
    add(x::Number) = x + 2
    add(x::Int) = x + 1

    @testset "simple" begin
        patches = Patch[
            @patch multiply(x::Integer) = 3x
            @patch multiply(x::Int) = 4x
            @patch add(x::Int) = x + 4
        ]

        apply(patches) do
            @test (@mock multiply(2)) == 8
            @test (@mock multiply(0x2)) == 0x6
            @test (@mock multiply(2//1)) == 4//1
            @test (@mock add(2//1)) == 4//1
            @test (@mock add(2)) == 6
        end

        apply(patches[1]) do
            @test (@mock multiply(2)) == 6
            @test (@mock multiply(0x2)) == 0x6
            @test (@mock multiply(2//1)) == 4//1
            @test (@mock add(2//1)) == 4//1
            @test (@mock add(2)) == 3

            apply(patches[2]) do
                @test (@mock multiply(2)) == 8
                @test (@mock multiply(0x2)) == 0x6
                @test (@mock multiply(2//1)) == 4//1
                @test (@mock add(2//1)) == 4//1
                @test (@mock add(2)) == 3

                apply(patches[3]) do
                    @test (@mock multiply(2)) == 8
                    @test (@mock multiply(0x2)) == 0x6
                    @test (@mock multiply(2//1)) == 4//1
                    @test (@mock add(2//1)) == 4//1
                    @test (@mock add(2)) == 6
                end

                @test (@mock multiply(2)) == 8
                @test (@mock multiply(0x2)) == 0x6
                @test (@mock multiply(2//1)) == 4//1
                @test (@mock add(2//1)) == 4//1
                @test (@mock add(2)) == 3
            end

            @test (@mock multiply(2)) == 6
            @test (@mock multiply(0x2)) == 0x6
            @test (@mock multiply(2//1)) == 4//1
            @test (@mock add(2//1)) == 4//1
            @test (@mock add(2)) == 3
        end
    end

    @testset "repeated patch" begin
        patches = Patch[
            @patch multiply(x::Integer) = 3x
            @patch multiply(x::Integer) = 4x
        ]

        apply(patches) do
            @test (@mock multiply(2)) == 8
        end

        apply(patches[1]) do
            @test (@mock multiply(2)) == 6
            apply(patches[2]) do
                @test (@mock multiply(2)) == 8
            end
            @test (@mock multiply(2)) == 6
        end
    end
end

@testset "mock keyword" begin
    f(; x=1) = x

    function f_param()
        x = 2
        return @mock f(; x=x)
    end

    @test f_param() == 2

    function f_kw()
        x = 3
        return @mock f(x=x)
    end

    @test f_kw() == 3

    @static if VERSION >= v"1.5"
        function f_req_param()
            x = 4
            return @mock f(; x)  # Testing keyword parameter that is just a `Symbol`
        end

        @test f_req_param() == 4
    end
end

@testset "patch" begin
    @testset "unnamed function" begin
        exception = VERSION >= v"1.7" ? ArgumentError : LoadError
        @test_throws exception macroexpand(@__MODULE__, :(@patch () -> nothing))
    end

    @testset "non-function definition" begin
        exception = VERSION >= v"1.7" ? ArgumentError : LoadError
        @test_throws exception macroexpand(@__MODULE__, :(@patch f()))
    end

    @testset "empty-function definition" begin
        exception = VERSION >= v"1.7" ? ArgumentError : LoadError
        @test_throws exception macroexpand(@__MODULE__, :(@patch function f end))
    end

    @testset "non-function definition" begin
        f() = 1
        p = @patch f() = 2
        @test p.target() == 1
        @test p.alternate() == 2
    end
end

# Test the basic concept behind call overloading
@testset "concept" begin
    multiply(x::Number) = 2x
    multiply(x::Int) = 2x - 1

    @test (@mock multiply(2)) == 3
    @test (@mock multiply(0x2)) == 0x4
    @test (@mock multiply(2//1)) == 4//1

    @test (@mock multiply(2)) == multiply(2)
    @test (@mock multiply(0x2)) == multiply(0x2)
    @test (@mock multiply(2//1)) == multiply(2//1)

    patches = Patch[
        @patch multiply(x::Integer) = 3x
        @patch multiply(x::Int) = 4x
    ]

    pe = Mocking.PatchEnv()
    for p in patches
        Mocking.apply!(pe, p)
    end
    Mocking.set_active_env(pe)

    @test (@mock multiply(2)) == 8        # calls mocked `multiply(::Int)`
    @test (@mock multiply(0x2)) == 0x6    # calls mocked `multiply(::Integer)`
    @test (@mock multiply(2//1)) == 4//1  # calls original `multiply(::Number)`

    @test (@mock multiply(2)) != multiply(2)
    @test (@mock multiply(0x2)) != multiply(0x2)
    @test (@mock multiply(2//1)) == multiply(2//1)

    # Clean env
    pe = Mocking.PatchEnv()
    Mocking.set_active_env(pe)

    # Ensure that original behaviour is restored
    @test (@mock multiply(2)) == 3
    @test (@mock multiply(0x2)) == 0x4
    @test (@mock multiply(2//1)) == 4//1

    # Use convenient syntax
    apply(patches) do
        @test (@mock multiply(2)) == 8
        @test (@mock multiply(0x2)) == 0x6
        @test (@mock multiply(2//1)) == 4//1
    end

    # Patches should only be applied for the scope of the do block
    @test (@mock multiply(2)) == 3
    @test (@mock multiply(0x2)) == 0x4
    @test (@mock multiply(2//1)) == 4//1
end

using Base: depwarn

function ismocked(pe::PatchEnv, func_name::Symbol, args::Tuple)
    m = @__MODULE__
    depwarn("`$m.ismocked` is no longer used and can be safely removed.", :ismocked)
    return false
end

# Note: The `depwarn` call here is similar to using `@deprecate` but instead shows a fully
# qualified function name.
function enable(; force=false)
    m = @__MODULE__
    depwarn(
        "`$m.enable(; force=$force)` is deprecated, use `$m.activate()` instead.",
        :enable,
        # format trick: using this comment to force use of multiple lines
    )
    return activate()
end

function activate(f)
    m = @__MODULE__
    depwarn("`$m.activate(f)` is deprecated and will be removed in the future.", :activate)

    started_deactivated = !activated()
    try
        activate()
        Base.invokelatest(f)
    finally
        started_deactivated && deactivate()
    end
end

function deactivate()
    m = @__MODULE__
    depwarn(
        "`$m.deactivate()` is deprecated and will be removed in the future.",
        :deactivate,
        # format trick: using this comment to force use of multiple lines
    )

    # Avoid redefining `_activated` when it's already set appropriately
    Base.invokelatest(activated) && @eval _activated(::Int) = false
    return nothing
end

# https://github.com/JuliaTesting/Mocking.jl/issues/92
@testset "ContextVariableX logging incompatibility" begin
    generate_report() = "original"
    report_patch = @patch generate_report() = "mocked"

    apply(report_patch) do
        @test (@test_logs @mock generate_report()) == "mocked"
    end
end

# Testcase from example given in Mocking.jl's documentation
@testset "randdev" begin
    # Note: Function only works in UNIX environments.
    function randdev(n::Integer)
        @mock open("/dev/urandom") do fp
            reverse(read(fp, n))
        end
    end

    n = 10
    if Sys.isunix()
        result = randdev(n)  # Reading /dev/urandom only works on UNIX environments
        @test eltype(result) == UInt8
        @test length(result) == n
    end

    # Produces a string with sequential UInt8 values from 1:n
    data = unsafe_string(pointer(convert(Array{UInt8}, 1:n)))

    # Generate a alternative method of `open` which call we wish to mock
    patch = @patch open(fn::Function, f::AbstractString) = fn(IOBuffer(data))

    # Apply the patch which will modify the behaviour for our test
    apply(patch) do
        @test randdev(n) == convert(Array{UInt8}, n:-1:1)
    end

    if Sys.isunix()
        # Outside of the scope of the patched environment `@mock` is essentially a no-op
        @test randdev(n) != convert(Array{UInt8}, n:-1:1)
    end
end

@testset "activate(func)" begin
    add1(x) = x + 1
    patch = @patch add1(x) = x + 42

    # Starting with Mocking enabled.
    Mocking.activate()
    @test Mocking.activated()
    @test_deprecated Mocking.activate() do
        apply(patch) do
            @test (@mock add1(2)) == 44
        end
    end
    @test Mocking.activated()

    # Starting with Mocking disabled.
    # Make sure to leave it enabled for the rest of the tests.
    try
        @test_deprecated Mocking.deactivate()
        @test !Mocking.activated()
        @test_deprecated Mocking.activate() do
            apply(patch) do
                @test (@mock add1(2)) == 44
            end
        end
        @test !Mocking.activated()
    finally
        Mocking.activate()
    end
end

# https://github.com/JuliaTesting/Mocking.jl/issues/14
@testset "patch generation" begin
    statuscode(url::AbstractString) = 500

    function foo(status::Int)
        @mock statuscode("http://httpbin.org/status/$status")
    end

    # Previously Mocking would modify the function expression in place. Reusing this
    # modified expression would cause the absolute_binding translation to fail upon
    # generating a second patch.
    patch(status) = @patch statuscode(url::AbstractString) = status

    apply(patch(200)) do
        @test foo(200) == 200
    end

    # Calling `patch` a second time would generate an exception
    apply(patch(404)) do
        @test foo(404) == 404
    end
end

@testset "open" begin
    # Ensure that open cannot find the file "foo"
    @test !isfile("foo")
    @test_throws SystemError open("foo")

    # Note that patches always have higher precedence. The patch `open(::Any)`
    # will be preferred over the original `open(::AbstractString)` for `open("foo")`
    patch = @patch open(name) = IOBuffer("bar")
    apply(patch) do
        @test read((@mock open("foo")), String) == "bar"

        # The `open(::Any)` patch could result in unintended (or intended) consequences
        @test read((@mock open(`echo helloworld`)), String) == "bar"
    end

    # Better to be specific with your patches
    patch = @patch open(name::AbstractString) = IOBuffer("bar")
    apply(patch) do
        @test read((@mock open("foo")), String) == "bar"

        # The more specific `open(::AbstractString)` patches only a single method
        result = @mock open(`echo helloworld`)
        io = result
        @test read(io, String) == "helloworld\n"
    end
end

# Creating a patch with an optional parameter
@testset "patch with optional parameter" begin
    hourvalue(h::Hour=Hour(0)) = Dates.value(h)

    patch = @patch hourvalue(h::Hour=Hour(21)) = 2 * Dates.value(h)
    apply(patch) do
        @test (@mock hourvalue()) == 42
        @test (@mock hourvalue(Hour(4))) == 8
    end
end

# Creating a patch with a keyword parameter
@testset "patch with keyword parameter" begin
    hourvalue(; hour::Hour=Hour(0)) = Dates.value(hour)

    patch = @patch hourvalue(; hour::Hour=Hour(21)) = 2 * Dates.value(hour)
    apply(patch) do
        @test (@mock hourvalue()) == 42

        # Test @mock calls with keyword arguments
        @test (@mock hourvalue(hour=Hour(4))) == 8      #:kw
        @test (@mock hourvalue(; hour=Hour(4))) == 8    #:parameters
    end
end

# Issue #15
@testset "anonymous parameter" begin
    f(::Type{T}, n::Int) where {T<:Unsigned} = rand(T, n)

    patch = @patch f(::Type{UInt8}, n::Int) = collect(UnitRange{UInt8}(1:n))

    apply(patch) do
        @test (@mock f(UInt8, 2)) == [0x01, 0x02]
    end
end

# Replacing `isfile(path...)` could be an issue due to its use of Varargs

@testset "isfile" begin
    null_file = string(@__FILE__, ".null")  # Note: tempfile() on Windows creates a file
    @test isfile(null_file) == false

    # Can't use `null_file` since closures don't currently work.
    # Note: @__FILE__ is resolved in the context of this file.
    patch = @patch isfile(p...) = first(p) == string(@__FILE__, ".null")
    apply(patch) do
        @test (@mock isfile(null_file)) == true
    end
end

"""
    @mock expr

Allows the call site function to be temporarily overloaded via an applied patch.

The `@mock` macro works as no-op until `Mocking.activate` has been called. Once Mocking has
been activated then alternative methods defined via [`@patch`](@ref) can be used with
[`apply`](@ref) to call the patched methods from within the `apply` context.

See also: [`@patch`](@ref), [`apply`](@ref).

## Examples

```jldoctest; setup=:(using Dates: Dates)
julia> f() = @mock time();

julia> p = @patch time() = 0.0;  # UNIX epoch

julia> apply(p) do
           Dates.unix2datetime(f())
       end
1970-01-01T00:00:00
```
"""
macro mock(expr)
    NULLIFIED[] && return esc(expr)  # Convert `@mock` into a no-op for maximum performace

    isa(expr, Expr) || error("argument is not an expression")
    expr.head == :do && (expr = rewrite_do(expr))
    expr.head == :call || error("expression is not a function call")

    target = expr.args[1]
    args = filter(!iskwarg, expr.args[2:end])
    kwargs = extract_kwargs(expr)

    # Due to how world-age works (see Julia issue #265 and PR #17057) when
    # `Mocking.activated` is overwritten then all dependent functions will be recompiled.
    # When `Mocking.activated() == false` then Julia will optimize the
    # code below to have zero-overhead by only executing the original expression.
    result = quote
        if $activated()
            args_var = tuple($(args...))
            alternate_var = $get_alternate($target, args_var...)
            if alternate_var !== nothing
                Base.invokelatest(alternate_var, args_var...; $(kwargs...))
            else
                $target(args_var...; $(kwargs...))
            end
        else
            $target($(args...); $(kwargs...))
        end
    end

    return esc(result)
end

function get_alternate(pe::PatchEnv, target, args...)
    if haskey(pe.mapping, target)
        m, f = dispatch(pe.mapping[target], args...)

        if pe.debug
            if m !== nothing
                @info _debug_msg(m, target, args)
            else
                target_m, _ = dispatch([target], args...)
                @info _debug_msg(target_m, target, args)
            end
        end

        return f
    else
        return nothing
    end
end

get_alternate(target, args...) = get_alternate(get_active_env(), target, args...)

function _debug_msg(method::Union{Method,Nothing}, target, args)
    call = "$target($(join(map(arg -> "::$(Core.Typeof(arg))", args), ", ")))"
    return """
        Mocking intercepted:
        call:       $call
        dispatched: $(method === nothing ? "(no matching method)" : method)
        """
end

# Depending on how the internals of `@patch` and `apply` are setup there could be issues
# with reusing a patch for a variety of reasons. These were discovered with experimenting
# with using Cassette with Mocking.

@testset "patch reuse" begin
    @testset "identical signature" begin
        # Declare the original function
        f() = 0

        # Create a patch `p1` and use it
        p1 = @patch f() = 1
        apply(p1) do
            @test (@mock f()) == 1
        end

        # Create another patch `p2` with the same function signature as `p1`
        p2 = @patch f() = 2
        apply(p2) do
            @test (@mock f()) == 2
        end

        # Verify we can re-use the `p1` patch
        apply(p1) do
            @test (@mock f()) == 1
        end
    end

    @testset "optional arguments" begin
        f(args::T...) where {T} = zero(T)

        # Create a patch function that contains two methods: `f(x)` and `f(x, y)`
        p1 = @patch f(x, y=0) = x + y
        apply(p1) do
            @test (@mock f(5)) == 5
        end

        # Create a second patch which could possibly interfere with `f(x)` from `p1` later
        p2 = @patch f(x) = -x
        apply(p2) do
            @test (@mock f(5)) == -5
        end

        # Validate that executing `f(x)` executes `f(x, 0)`
        apply(p1) do
            @test (@mock f(5)) == 5
        end
    end

    @testset "specificity" begin
        f(::Real) = Real

        # Create our initial patch
        p1 = @patch f(::Number) = Number
        apply(p1) do
            @test (@mock f(1)) == Number
        end

        # Create a second patch which is more specific than the first
        p2 = @patch f(::Integer) = Integer
        apply(p2) do
            @test (@mock f(1)) == Integer
        end

        # Validate that first patch is called and not the more specific second patch
        apply(p1) do
            @test (@mock f(1)) == Number
        end
    end
end

module Mocking

using Compat: mergewith
using ExprTools: splitdef, combinedef

export @patch, @mock, Patch, apply

include("expr.jl")
include("dispatch.jl")
include("patch.jl")
include("mock.jl")
include("deprecated.jl")

# Create the initial definition of `activated` which defaults having Mocking be deactivated.
# We utilize method invalidation as a feature here to allow functions using `@mock` to be
# automatically re-compiled after Mocking was activated.
#
# We slightly abuse multiple-dispatch here so that we avoid having a "method definition
# overwritten" for the first call to `Mocking.activate`. By defining a more specific method
# we avoid the warning but can still trigger invalidation.
_activated(::Integer) = false

"""
    Mocking.activated() -> Bool

Indicates if Mocking has been activated or not via `Mocking.activate`.
"""
activated() = _activated(0)

"""
    Mocking.activate() -> Nothing

Activates `@mock` call sites to allow for calling patches instead of the original function.
Intended to be called within a packages `test/runtests.jl` file.

!!! note
    Calling this causes functions which use `@mock` to become invalidated and re-compiled
    the next time they are called.
"""
function activate()
    # Avoid redefining `_activated` when it's already set appropriately
    !activated() && @eval _activated(::Int) = true
    return nothing
end

const NULLIFIED = Ref{Bool}(false)

"""
    Mocking.nullify() -> Nothing

Force any packages loaded after this point to treat the `@mock` macro as a no-op. Doing so
will maximize performance by eliminating any runtime checks taking place at the `@mock` call
sites but will break any tests that require patches to be applied.

Note to ensure that all `@mock` macros are inoperative be sure to call this function before
loading any packages which depend on Mocking.jl.
"""
function nullify()
    global NULLIFIED[] = true
    return nothing
end

end # module

@testset "type_morespecific" begin
    @testset "subtype" begin
        @test type_morespecific(Int, Integer)
        @test !type_morespecific(Integer, Int)
        @test !type_morespecific(Int, Int)
    end

    @testset "number of arguments" begin
        @test type_morespecific(Tuple{Int,AbstractFloat}, Tuple{Integer})
    end

    @testset "ambiguous" begin
        @test !type_morespecific(Tuple{Int,AbstractFloat}, Tuple{Integer,Float64})
        @test !type_morespecific(Tuple{Integer,Float64}, Tuple{Int,AbstractFloat})
    end

    @testset "length" begin
        @test type_morespecific(Tuple{Int,Int}, Tuple{Int,Vararg{Int}})
    end

    @testset "union" begin
        @test type_morespecific(Tuple{Int}, Tuple{Union{Int,Float64}})
        @test type_morespecific(Tuple{Union{Int,Float64}}, Tuple{Integer})
    end

    @testset "union all" begin
        @test type_morespecific(Tuple{Int}, Tuple{T} where {T<:Integer})

        @test !type_morespecific(Tuple{Integer}, Tuple{T} where {T<:Integer})
        @test !type_morespecific(Tuple{T} where {T<:Integer}, Tuple{Integer})

        @test type_morespecific(Tuple{Type{Integer}}, Tuple{Type{T}} where {T<:Integer})
        @test !type_morespecific(Tuple{Type{T}} where {T<:Integer}, Tuple{Type{Integer}})
    end
end

@testset "anonymous_signature" begin
    @testset "diagonal dispatch" begin
        diag(::T, ::T) where {T<:Integer} = nothing

        diag_method = first(methods(diag, (Int, Int)))
        diag_sig = Tuple{typeof(diag),T,T} where {T<:Integer}
        @test diag_method.sig == diag_sig

        @test anonymous_signature(Tuple{typeof(diag),Int,Int}) == Tuple{Int,Int}
        @test anonymous_signature(diag_sig) == Tuple{T,T} where {T<:Integer}
        @test anonymous_signature(diag_method) == Tuple{T,T} where {T<:Integer}
    end

    @testset "triangular dispatch" begin
        tri(::Vector{T}, ::S) where {T,S<:T} = nothing

        tri_method = first(methods(tri, (Vector, Int)))
        tri_sig = Tuple{typeof(tri),Vector{T},S} where {T,S<:T}
        @test tri_method.sig == tri_sig

        @test anonymous_signature(Tuple{typeof(tri),Vector,Int}) == Tuple{Vector,Int}
        @test anonymous_signature(tri_sig) == Tuple{Vector{T},S} where {T,S<:T}
        @test anonymous_signature(tri_method) == Tuple{Vector{T},S} where {T,S<:T}
    end
end

@testset "anon_morespecific" begin
    plus_method = first(methods(+, (Int, Int)))
    max_method = first(methods(max, (Int, Int)))

    @test !type_morespecific(plus_method.sig, max_method.sig)
    @test anon_morespecific(plus_method, max_method)
end

@testset "dispatch" begin
    @testset "no functions" begin
        m, f = dispatch(Function[])
        @test f === nothing
        @test m === nothing
    end

    @testset "no methods" begin
        m, f = dispatch([function f0 end])
        @test f === nothing
        @test m === nothing
    end

    @testset "no arguments" begin
        #! format: off
        funcs = [
            () -> 1
        ]
        #! format: on

        m, f = dispatch(funcs)
        @test f == funcs[1]
        @test m.sig == Tuple{typeof(funcs[1])}
    end

    @testset "more specific function" begin
        funcs = [
            (::Int) -> 1
            (::Integer) -> 2
        ]

        m, f = dispatch(funcs, zero(Int))
        @test f == funcs[1]
        @test m.sig == Tuple{typeof(funcs[1]),Int}

        m, f = dispatch(funcs, zero(UInt))
        @test f == funcs[2]
        @test m.sig == Tuple{typeof(funcs[2]),Integer}
    end

    @testset "more specific method" begin
        f1(::Number) = 1
        f1(::Int) = 2
        f2(::Any) = 3
        f2(::Integer) = 4
        funcs = [f1, f2]

        m, f = dispatch(funcs, zero(Int))
        @test f == funcs[1]
        @test m.sig == Tuple{typeof(funcs[1]),Int}

        m, f = dispatch(funcs, zero(UInt))
        @test f == funcs[2]
        @test m.sig == Tuple{typeof(funcs[2]),Integer}
    end

    @testset "ambiguous" begin
        funcs = [
            (::Integer) -> 1
            (::Integer) -> 2
        ]

        # In ambiguous cases the last function is preferred
        m, f = dispatch(funcs, 0)
        @test f == funcs[2]
        @test m.sig == Tuple{typeof(funcs[2]),Integer}

        m, f = dispatch(reverse(funcs), 0)
        @test f == funcs[1]
        @test m.sig == Tuple{typeof(funcs[1]),Integer}
    end

    @testset "optional" begin
        funcs = [
            (x, y=0) -> 1
            (x) -> 2
        ]

        m, f = dispatch(funcs, 0)
        @test f == funcs[2]
        @test m.sig == Tuple{typeof(funcs[2]),Any}

        m, f = dispatch(funcs, 0, 0)
        @test f == funcs[1]
        @test m.sig == Tuple{typeof(funcs[1]),Any,Any}

        m, f = dispatch(reverse(funcs), 0)
        @test f == funcs[1]
        @test m.sig == Tuple{typeof(funcs[1]),Any}
    end

    @testset "Type{T}" begin
        funcs = [
            (::Type{Integer}) -> 1
            (::Type{Int}) -> 2
        ]

        m, f = dispatch(funcs, 0)
        @test f === nothing
        @test m === nothing

        m, f = dispatch(funcs, Integer)
        @test f == funcs[1]
        @test m.sig == Tuple{typeof(funcs[1]),Type{Integer}}

        m, f = dispatch(reverse(funcs), Type{Integer})
        @test f === nothing
        @test m === nothing
    end

    @testset "Type{T} where T" begin
        funcs = [
            (::Type{Int}) -> 1
            (::Type{<:Integer}) -> 2
        ]

        m, f = dispatch(funcs, Int)
        @test f == funcs[1]
        @test m.sig == Tuple{typeof(funcs[1]),Type{Int}}

        m, f = dispatch(reverse(funcs), Integer)
        @test f == funcs[2]
        @test m.sig == Tuple{typeof(funcs[2]),Type{<:Integer}}
    end
end

# Make sure that arguments are only evaluated once
@testset "one-time argument evaluation" begin
    function counter()
        i = 0
        count() = i += 1
        return count
    end

    p = @patch string(x) = "$x"

    # Check code path where we execute a patch
    c = counter()
    apply(p) do
        @test (@mock string(c())) == "1"
    end

    # Check code path where we fallback to the original function
    c = counter()
    apply(Patch[]) do
        @test (@mock string(c())) == "1"
    end
end

# New do-block syntax introduced in: https://github.com/JuliaLang/julia/pull/23718
function rewrite_do(expr::Expr)
    expr.head == :do || error("expression is not a do-block")
    call, body = expr.args
    return Expr(:call, call.args[1], body, call.args[2:end]...)
end

iskwarg(x::Any) = isa(x, Expr) && (x.head === :parameters || x.head === :kw)

"""
    extract_kwargs(expr::Expr) -> Vector{Union{Expr,Symbol}}

Extract the :parameters and :kw value into an array of :kw expressions
we don't evaluate any expressions for values yet though.
"""
function extract_kwargs(expr::Expr)
    kwargs = Union{Expr,Symbol}[]
    for x in expr.args[2:end]
        if iskwarg(x)
            if x.head === :parameters
                for kw in x.args
                    push!(kwargs, kw)
                end
            else
                push!(kwargs, x)
            end
        end
    end
    return kwargs
end

@testset "tasks" begin
    c = Condition()
    ch = Channel{String}(1)
    f() = "original"
    function background()
        # Wait until notified allowing us to control when this async code is executed
        wait(c)
        put!(ch, @mock f())
        return nothing
    end

    p = @patch f() = "mocked"

    @sync begin
        # Task started outside patched context should not call patched functions.
        @async background()
        yield()

        apply(p) do
            @test (@mock f()) == "mocked"

            notify(c)
            @test_broken take!(ch) == "original"

            # Task started inside patched context should call patched functions.
            @async background()
            yield()
            notify(c)
            @test take!(ch) == "mocked"

            # Task started inside patched context should call patched functions even when
            # execution finishes outside of patched context.
            @async background()
            yield()
        end

        notify(c)
        @test_broken take!(ch) == "mocked"
    end
end

@testset "merge PatchEnv instances" begin
    multiply(x::Number) = 2x
    multiply(x::Int) = 2x - 1
    add(x::Number) = x + 2
    add(x::Int) = x + 1

    patches = Patch[
        @patch multiply(x::Integer) = 3x
        @patch multiply(x::Int) = 4x
        @patch add(x::Int) = x + 4
    ]

    @testset "simple" begin
        pe1 = Mocking.PatchEnv(patches[1])
        pe2 = Mocking.PatchEnv(patches[2:3])
        pe = Mocking.PatchEnv(patches)

        @test pe == merge(pe1, pe2)
    end

    @testset "debug flag" begin
        pe1 = Mocking.PatchEnv(patches[1], true)
        pe2 = Mocking.PatchEnv(patches[2:3])
        pe = Mocking.PatchEnv(patches, true)

        @test pe == merge(pe1, pe2)
    end
end

# Mocking

Allows Julia function calls to be temporarily overloaded for the purpose of testing.

## `randdev` Example

Suppose you wrote the function `randdev` (UNIX only). How would you go about writing tests
for it?

```jldoctest randdev; output=false
function randdev(n::Integer)
    open("/dev/urandom") do fp
        reverse(read(fp, n))
    end
end

# output
randdev (generic function with 1 method)
```

The non-deterministic behaviour of this function makes it hard to test but we can write some
tests dealing with the deterministic properties of the function such as:

```jldoctest randdev; output=false
using Test
# using ...: randdev

n = 10
result = randdev(n)
@test eltype(result) == UInt8
@test length(result) == n

# output
Test Passed
```

How could we create a test that shows the output of the function is reversed? Mocking.jl
provides the `@mock` macro which allows package developers to temporarily overload a
specific calls in their package. In this example we will apply `@mock` to the `open` call
in `randdev`:

```jldoctest randdev_mock; output=false
using Mocking: @mock

function randdev(n::Integer)
    @mock open("/dev/urandom") do fp
        reverse(read(fp, n))
    end
end

# output
randdev (generic function with 1 method)
```

With the call site being marked as "mockable" we can now write a testcase which allows
us to demonstrate the reversing behaviour within the `randdev` function:

```jldoctest randdev_mock; output=false
using Mocking
using Test
# using ...: randdev

Mocking.activate()  # Need to call `activate` before executing `apply`

n = 10
result = randdev(n)
@test eltype(result) == UInt8
@test length(result) == n

# Produces a string with sequential UInt8 values from 1:n
data = unsafe_string(pointer(convert(Array{UInt8}, 1:n)))

# Generate an alternative method of `open` which call we wish to mock
patch = @patch open(fn::Function, f::AbstractString) = fn(IOBuffer(data))

# Apply the patch which will modify the behaviour for our test
apply(patch) do
    @test randdev(n) == convert(Array{UInt8}, n:-1:1)
end

# Outside of the scope of the patched environment `@mock` is essentially a no-op
@test randdev(n) != convert(Array{UInt8}, n:-1:1)

# output
Test Passed
```

# FAQ

```@meta
CurrentModule = Mocking
```

## What kind of overhead does `@mock` add?

The [`@mock`](@ref) macro is a no-op and has zero overhead when mocking has not been activated via
[`Mocking.activate()`](@ref activate). Users can use `@code_llvm` on their code with and without `@mock` to
confirm the macro has no effect.

When `Mocking.activate` is called Mocking.jl will re-define a function utilized by `@mock`
which results in invalidating any functions using the macro. The result of this is that when
running your tests will cause those functions to be recompiled the next time they are called
such that the alternative code path provided by patches can be executed.

## Why isn't my patch being called?

When your patch isn't being applied you should remember to check for the following:

- [`Mocking.activate`](@ref activate) is called before the [`apply`](@ref) call.
- Call sites you want to patch are using [`@mock`](@ref).
- The patch's argument types are supertypes the values passed in at the call site.

## Where should I add `Mocking.activate()`?

We recommend putting the call to [`Mocking.activate`](@ref activate) in your package's
`test/runtests.jl` file after all of your import statements. The only true requirement is
that you call  `Mocking.activate()` before the first [`apply`](@ref) call.
